// vector.cpp - Definición de la clase CVector
#include <iostream>
#include "vector.h"
using namespace std;

// Constructores:
// Crear una matriz con 10 elementos por omisión
CVector::CVector()
{
  nElementos = 10;
  vector = asignarMem(nElementos);
  fill(vector, vector + nElementos, 0);
}

// Crear una matriz con ne elementos
CVector::CVector(int ne)
{
  if (ne < 1)
  {
    cerr << "Nº de elementos no válido: " << ne << "\n";
    return;
  }
  nElementos = ne;
  vector = asignarMem(nElementos);
  fill(vector, vector + nElementos, 0);
}

// Crear una matriz a partir de otra matriz primitiva
CVector::CVector(double *a, int ne)
{
  nElementos = ne;
  vector = asignarMem(nElementos);
  // Copiar los elementos de la matriz a
  for (int i = 0; i < nElementos; i++)
    vector[i] = a[i];
}

// Constructor copia
CVector::CVector(const CVector &v)
{
  nElementos = v.nElementos;
  vector = asignarMem(nElementos);
  // Copiar el objeto v
  for (int i = 0; i < nElementos; i++)
    vector[i] = v.vector[i];
}

// Otros métodos
CVector::~CVector() // destructor
{
  delete [] vector;
}

double& CVector::elemento(int i) const
{
  return vector[i];
}

int CVector::longitud() const
{
  return nElementos;
}

double *CVector::asignarMem(int nElems)
{
  try
  {
    double *p = new double[nElems];
    return p;
  }
  catch(bad_alloc e)
  {
    cout << "Insuficiente espacio de memoria\n";
    exit(-1);
  }
}

